//
// Arduino Uno comms test
//

bool RxMsgReadyFlg = false;
String serialInputLine;

//
// Usage: Set serial monitor to 155,200 Baud, and select Newline 
//
// If you send "Version", Arduino Uno should return "Trackgen V1.0" - any other input will be ignored. Input is not case-sensitive.
//
// Timeout is set to 5 seconds. If you send "Version" without ANY terminating character, Serial.readStringUntil will timeout
// after 5 seconds and will return whatever was in the receive buffer. If you sent "Version" with the incorrect terminator, then 
// you will see "Trackgen V1.0" after 5 seconds.
//
// If comms is working correctly, you should receive "Trackgen V1.0" immediately without the 5 second delay.
//

void setup()
{
  Serial.begin(115200);
  Serial.setTimeout(5000);
  
  RxMsgReadyFlg = false;
  sei();
}

void loop()
{
    serialEventRun();

    if (RxMsgReadyFlg)
    {
      serialInputLine.toUpperCase();
      
      if(serialInputLine == "VERSION")
        Serial.println("Trackgen V1.0");

      RxMsgReadyFlg = false;
    }
}

void serialEvent()
{
  while (Serial.available())
  {
    // read until newline detected  - newline char is discarded
    
    serialInputLine = Serial.readStringUntil('\n');
    RxMsgReadyFlg = true;
  }
}

